[leetcode]: 405. Convert a Number to Hexadecimal

1.题目

Given an integer, write an algorithm to convert it to hexadecimal. For negative integer, two’s complement method is used.

Note:
All letters in hexadecimal (a-f) must be in lowercase.
The hexadecimal string must not contain extra leading 0s. If the number is zero, it is represented by a single zero character ‘0’; otherwise, the first character in the hexadecimal string will not be the zero character.
The given number is guaranteed to fit within the range of a 32-bit signed integer.
You must not use any method provided by the library which converts/formats the number to hex directly.
给一个32位整数,求16进制表示。负数用补码。

2.分析

一开始挺傻的,老老实实按16进制转换来做,负数还求了反码+1.
然而!!错了,因为-2147483648求反码的时候会溢出。因为正数最大表示为2147483647。不过这个问题后来也可以通过将int转换为long long来解决。

偷瞄了solution,原来别人都是用位运算来做的。唉,刷了这么久的题也没学会套路。
就想字符串一类的题,每次都老老实实遍历if else一大堆,到头来一看solution,人家一行正则表达式就搞定了。还是得长点心啊。

3.代码

正解。别想着自己转换进制了,数在计算机里本来就是按二进制存的。多用位运算。

string toHex(int n) {
    if (n == 0)
        return "0";
    string HEX = "0123456789abcdef";
    vector<char> result;
    int count = 0;
    while (n && count++ < 8) {
        result.push_back(HEX[n & 0xf]);
        n >>= 4;
    }
    return string(result.rbegin(), result.rend());

我的挫挫的解

class Solution {
public:
    string toHex(int n) {
        long long num=n;
        if (num == 0)
            return "0";
        vector<char> hex;
        vector<int> neg;
        string match= "0123456789abcdef";
        bool sign = num > 0 ? true : false;
        num = num > 0 ? num : -num;
        while (num > 0) {
            if(sign)//正数,原码
                hex.push_back(match[num % 16]);
            else//负数,反码
                neg.push_back(15-num % 16);
            num /= 16;
        }
        if (!sign)//反码+1
        {
            for (int i = neg.size(); i < 8; i++) {
                neg.push_back(15);
            }
            int carry = 1; 
            for (int i = 0; i < neg.size(); i++) {
                carry = neg[i] + carry;
                hex.push_back(match[carry % 16]);
                carry = carry / 16;
            }
        }
        return string(hex.rbegin(), hex.rend());
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值